
; User modifiable constants

OBJ_MAX_COUNT = 128
; OFFSCREEN_SPRITES_BY_X = 1 ; Uncomment if using 240 pixel height screen
; CYCLE_COUNT_VBLANK = 1 ; Uncomment to use the precise cycle counting wait function for profiling (not battery-friendly)

; Fixed or internal use constants. Do not change these unless you're making engine modifications!

; Data structure fields

SPRITEDEF_X = $0000
SPRITEDEF_Y = $0002
SPRITEDEF_SIZE = $0004
SPRITEDEF_ATTRIBUTES = $0005
SPRITEDEF_NEXTDEF = $0007

ANIMDEF_DELAY = $0000
ANIMDEF_NEXT = $0001
ANIMDEF_DATA = $0003
ANIMDEF_DATAEX = $0005

PPUDEF_OBJSEL = $0000
PPUDEF_BGMODE = $0001
PPUDEF_BG1TILEMAP = $0002
PPUDEF_BG2TILEMAP = $0003
PPUDEF_BG3TILEMAP = $0004
PPUDEF_BG4TILEMAP = $0005
PPUDEF_BG12CHAR = $0006
PPUDEF_BG34CHAR = $0007
PPUDEF_MODE7SEL = $0008
PPUDEF_WIN12SEL = $0009
PPUDEF_WIN34SEL = $000a
PPUDEF_WINOBJSEL = $000b
PPUDEF_WINBGLOGIC = $000c
PPUDEF_WINOBJLOGIC = $000d
PPUDEF_DESTMAIN = $000e
PPUDEF_DESTSUB = $000f
PPUDEF_WINMAIN = $0010
PPUDEF_WINSUB = $0011
PPUDEF_COLORMATHSEL = $0012
PPUDEF_COLORMATHDEST = $0013
PPUDEF_FIXEDCOLOR = $0014
PPUDEF_SETINI = $0016

; OAM/PPU constants

OAM_X = $0000
OAM_Y = $0001
OAM_ATTRIBUTES = $0002

SPRITE_SMALL = $00
SPRITE_LARGE = $02

PPU_OBJSIZE_8_16 =  %00000000
PPU_OBJSIZE_8_32 =  %00100000
PPU_OBJSIZE_16_32 = %01100000

PPU_OBJCHARADDR_0     = %00000000
PPU_OBJCHARADDR_2000  = %00000001
PPU_OBJCHARADDR_4000  = %00000010
PPU_OBJCHARADDR_6000  = %00000011

PPU_TILEMAPSIZE_32_32 = %00000000
PPU_TILEMAPSIZE_64_32 = %00000001
PPU_TILEMAPSIZE_32_64 = %00000010
PPU_TILEMAPSIZE_64_64 = %00000011

PPU_TILEMAPADDR_0     = %00000000
PPU_TILEMAPADDR_400   = %00000100
PPU_TILEMAPADDR_800   = %00001000
PPU_TILEMAPADDR_1000  = %00010000
PPU_TILEMAPADDR_2000  = %00100000
PPU_TILEMAPADDR_4000  = %01000000
PPU_TILEMAPADDR_6000  = %01100000
PPU_TILEMAPADDR_6800  = %01101000
PPU_TILEMAPADDR_7000  = %01110000
PPU_TILEMAPADDR_7800  = %01111000

PPU_BGCHARADDR_0       = %00000000
PPU_BG13CHARADDR_1000  = %00000001
PPU_BG13CHARADDR_2000  = %00000010
PPU_BG13CHARADDR_3000  = %00000011
PPU_BG13CHARADDR_4000  = %00000100
PPU_BG24CHARADDR_1000  = %00010000
PPU_BG24CHARADDR_2000  = %00100000
PPU_BG24CHARADDR_3000  = %00110000
PPU_BG24CHARADDR_4000  = %01000000

; Gameobject constants

OBJ_VAR_SIZE = OBJ_MAX_COUNT * 3

; Input constants

INPUT_RIGHT = $0100
INPUT_LEFT = $0200
INPUT_DOWN = $0400
INPUT_UP = $0800
INPUT_START = $1000
INPUT_SELECT = $2000
INPUT_Y = $4000
INPUT_B = $8000
INPUT_R = $0010
INPUT_L = $0020
INPUT_X = $0040
INPUT_A = $0080

; Sound driver constants

SPC_CMD_NONE =             $00
SPC_CMD_INITIALIZE =       $01
SPC_CMD_LOAD =             $02
SPC_CMD_STEREO =           $03
SPC_CMD_GLOBAL_VOLUME =    $04
SPC_CMD_CHANNEL_VOLUME =   $05
SPC_CMD_MUSIC_PLAY =       $06
SPC_CMD_MUSIC_STOP =       $07
SPC_CMD_MUSIC_PAUSE =      $08
SPC_CMD_SFX_PLAY =         $09
SPC_CMD_STOP_ALL_SOUNDS =  $0a
SPC_CMD_STREAM_START =     $0b
SPC_CMD_STREAM_STOP =      $0c
SPC_CMD_STREAM_SEND =      $0d

SPC_SFX_PLAY_CHANNEL_A =   $69
SPC_SFX_PLAY_CHANNEL_B =   $79
