
local cabin = require "src.utils.cabin"
local oops = require "src.utils.oops"
local test = require "src.utils.test"

local DataObject = oops.BaseObject:makeClass
{
    
}

function DataObject:init(file)
    if file then
        self:loadFromFile(file)
    end
end

function DataObject:loadFromFile(file)
    self.file = file
    
    cabin.info("Reading file: " .. file:getFilename())
    
    local ok, errorString = file:open("r")
    
    if not ok then
        error("Failed to open file: " .. file:getFilename())
        return
    end
    
    local fileData, dataSize = file:read()
    
    file:close()
    
    cabin.info("Read " .. dataSize .. " bytes.")
    
    self:loadData(fileData, dataSize)
end

function DataObject:saveToFile()
    local file = self.file
    
    cabin.info("Writing file: " .. file:getFilename())
    
    local ok, errorString = file:open("w")
    
    if not ok then
        error("Failed to open file: " .. file:getFilename())
        return
    end
    
    local fileData = self:saveData()
    local success, message = file:write(fileData)
    
    if not success then
        error("Failed to write to file: " .. message)
    end
    
    file:close()
end

function DataObject:loadData(fileData, dataSize)
    test.implementMe()
end

function DataObject:saveData()
    test.implementMe()
end

return DataObject
